/*#
# **************************************************************
# *                  SIMUSOL PROYECT                           *
# *                                                            *
# *         Table extension for:                               *
# *         C++ Mathematical Expression Toolkit Library        *
# *         which is located in:                               *
# * URL: http://www.partow.net/programming/exprtk/index.html   *
# *                                                            *
# *   The extension was developed by                           *
# *   Diego.Saravia@gmail.com, 2016                            *
# *   and could be used in the same terms of the toolkit       *
# *   or every free license with copyleft needed.              *
# *   http://www.simusol.org                                   *
# **************************************************************


 * Uses Check: a unit test framework for C
 * Copyright (C) 2001, 2002 Arien Malec

# This file is part of Table.
#
#    Table is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Table is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Table.  If not, see <http://www.gnu.org/licenses/>.*/


 

#define _GNU_SOURCE 
#include <check.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "/usr/local/include/check.h"
#include <malloc.h>





#include "../src/simusol_table.h"
int finddir(char ** dir);



// finddir tambien en summapack, para sacar dependencias se copia (example lo mismo)
#include <unistd.h>
#include <limits.h>
#include <libgen.h>

int finddir(char ** dir);


int finddir(char ** dire){
  char buf[300];
   char bufe[300];
   char *buf2;
  char *pc;
  char *buf3;
  char *pc2;
  if (readlink("/proc/self/exe", buf, sizeof(buf)) < 0){
        perror("readlink() error");
	exit;
  }
 else {
   pc=strdup(buf);
   buf2=dirname(pc);
   pc2=strdup(buf2);
   asprintf(dire,"%s/",dirname(pc2));
  
   printf("readlink() returned '%s' for '%s'- %s\n", buf, "/proc/self/exe",*dire);
 
 
 }
} 







char *gdir1 =NULL;
char *gdir2 =NULL;
char *gdir3 =NULL;
char *strlist=NULL;

START_TEST(test_simusol_table_sourcedirs)
  printf("DIR1 %s\n",gdir1);
  printf("DIR2 %s\n",gdir2);
  printf("DIR3 %s\n",gdir3);
  printf("STRDIR %s\n",strlist);
  ck_assert_msg(1,"Assert all %s\n", "OK"); // learning
END_TEST

START_TEST(test_simusol_table_interpolate1)
  double result;
  int ret=interpolate(gdir1,"UNO","DOS",1050.,1, &result);
  if (ret <0){
	       exit(ret);
	       /* Don't know how to handle evaluation errors in exprtk*/
               }
  printf("---RESULTADO %d, %g: %g\n",1,1050.,result);
//ck_assert_msg(fabs(result-32.08) < 0.01,"\nBad\n====================================================================\n"); //

//http://stackoverflow.com/questions/11747251/comparing-double-values-in-c
//https://randomascii.wordpress.com/2012/06/26/doubles-are-not-floats-so-dont-compare-them/
		//ck_assert_msg(strcmp (money_currency (m), "USD") == 0,
		//"Was expecting a currency of USD, but found %s", money_currency (m));
if (fabs(result-32.08)>0.01 )
  {
    printf ("\nTEST ERROR Bad result\n====================================================================\n");
    //fail ("\nTEST ERROR Bad result\n====================================================================\n");
    //ck_abort_msg ("\nTEST ERROR Bad result\n====================================================================\n");
  }else{
    printf("\nTEST OK\n");
    } 

END_TEST

START_TEST(test_simusol_table_interpolate2)
  double result;
  int ret=interpolate(gdir1,"UNO","DOS",1050.,2, &result);
  if (ret <0){
	       exit(ret);
	       /* Don't know how to handle evaluation errors in exprtk*/
               }
  printf("---RESULTADO %d, %g: %g\n",2,1050.,result);

END_TEST
START_TEST(test_simusol_table_interpolate3)    // OJO si no encuentra file sigue y da cosas raras!!!!
        double result;
        int    ret=interpolate(gdir2,"UNO","DOS",1050.,1, &result);
         if (ret <0){
	       exit(ret);
               }
	 printf("---RESULTADO INTERPOLATE 3 %d, %g\n",1,result);



END_TEST
START_TEST(test_simusol_table_list_table)    // OJO si no encuentra file sigue y da cosas raras!!!!

     unsigned int num_table=0;
     unsigned int num_view=0;
     get_numbers(gdir2,"UNO","DOS",&num_table,&num_view);
     print_table(num_table);

END_TEST
START_TEST(test_simusol_table_gnuplot)  

  //lista de archivos
  const char *list_tables = strlist;

  unsigned int numtable;
 
  read_string_tables(list_tables ,&numtable ); 

  //int error=
  create_search_table(gdir1, &numtable);  // aqui ya esta creada y la busco

  printf("TABLA ENCONTRADA %s - %d \n",gdir1,numtable); // poner string 

    unsigned int vistan=0;
    int erroro=create_search_view(numtable,"UNO","DOS",&vistan);   
    if (erroro<0){
       exit (erroro);
       }

    //occup %d    tablelist->occupy,   hacer funcion que de eso
    
    printf("Funcion c test.\n   numtable %d vista %d\n",numtable,vistan);
  
    gnuplot_view(numtable,vistan);

END_TEST
START_TEST(test_simusol_table_qty_tables)
     const char *list_tables = strlist;
     unsigned int numtable; 
     read_string_tables(list_tables ,&numtable ); 

     unsigned int num_tables;
int ret=get_qty_tables (&num_tables);
printf("++++++++++++++++++++++++++NUM TAB %d\n",num_tables);
END_TEST
START_TEST(test_simusol_table_table_info1)
     const char *list_tables = strlist;
     unsigned int numtable; 
     read_string_tables(list_tables ,&numtable ); 

     unsigned int num_table=0;  //arreglar tablas DOSxs
     const char *s;
     unsigned int nok;
     unsigned int tl;
     unsigned int cl0;
     int ret=get_table_info(num_table, &s,&tl,&cl0);
     printf("++++++++++++++++++++++++++++NOMBRE %s NUM COL %d %d\n",s,tl,cl0);

END_TEST
START_TEST(test_simusol_table_table_info2)
     const char *list_tables = strlist;
     unsigned int numtable; 
     read_string_tables(list_tables ,&numtable ); 

     unsigned int num_table=1;  //arreglar tablas DOSxs
     const char *s;
     unsigned int nok;
     unsigned int tl;
     unsigned int cl0;
     int ret=get_table_info(num_table, &s,&tl,&cl0);
     printf("++++++++++++++++++++++++++++NOMBRE %s NUM COL %d %d\n",s,tl,cl0);

END_TEST
START_TEST(test_simusol_table_table_info3)
     const char *list_tables = strlist;
     unsigned int numtable; 
     read_string_tables(list_tables ,&numtable ); 

     unsigned int num_table=2;  //arreglar tablas DOSxs
     const char *s;
     unsigned int nok;
     unsigned int tl;
     unsigned int cl0;
     int ret=get_table_info(num_table, &s,&tl,&cl0);
     printf("++++++++++++++++++++++++++++NOMBRE %s NUM COL %d %d\n",s,tl,cl0);

     print_table(num_table);
END_TEST

Suite * simusol_table_suite(void)
{
    Suite *s;
    TCase *tc_core;
    s = suite_create("simusol_table");

    /* Core test case */
    tc_core = tcase_create("Core");
    tcase_add_test(tc_core, test_simusol_table_sourcedirs);
    tcase_add_test(tc_core, test_simusol_table_interpolate1);
    tcase_add_test(tc_core, test_simusol_table_interpolate2);
    tcase_add_test(tc_core, test_simusol_table_interpolate3);
    tcase_add_test(tc_core, test_simusol_table_gnuplot);
    tcase_add_test(tc_core, test_simusol_table_qty_tables);
    tcase_add_test(tc_core, test_simusol_table_table_info1);
    tcase_add_test(tc_core, test_simusol_table_table_info2);
    tcase_add_test(tc_core, test_simusol_table_table_info3);
        tcase_add_test(tc_core,test_simusol_table_list_table);
    
    suite_add_tcase(s, tc_core);

    return s;
}

 int main(void)
 {
   char *dir;
   finddir(&dir);
   char *ldir1="data/testU.txt";
   char *ldir2="data/test.txt";
   char *ldir3="data/data.txt";
   size_t lendir = strlen(dir);
   size_t len1 = strlen(ldir1);
   size_t len2 = strlen(ldir2);
   size_t len3 = strlen(ldir3);
   gdir1 = malloc(lendir+len1+1);//+1 for the zero-terminator
   gdir2 = malloc(lendir+len2+1);
   gdir3 = malloc(lendir+len3+1);
   //in real code you would check for errors in malloc here
   memcpy(gdir1, dir, lendir);
   memcpy(gdir2, dir, lendir);
   memcpy(gdir3, dir, lendir);
   memcpy(gdir1+lendir, ldir1, len1+1);
   memcpy(gdir2+lendir, ldir2, len2+1);
   memcpy(gdir3+lendir, ldir3, len3+1);
   asprintf(&strlist,"%s,%s,%s,MAR,K,J,I",gdir1,gdir2,gdir3);
      
    int number_failed;
    Suite *s;
    SRunner *sr;

    s = simusol_table_suite();
    sr = srunner_create(s);

    srunner_run_all(sr, CK_NORMAL);
    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);

    free(strlist);
    free(gdir1);
    free(gdir2);
    free(gdir3);
    printf( "=====================================================================\n");
    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
 }

